SystemOrganization addCategory: #BackgammonView!

TestCase subclass: #DieMorphTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonView'!

!DieMorphTestCase methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 07:32'!
testDie
	(DieMorph faces: 6) openInWorld.! !

!DieMorphTestCase methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/22/2015 07:27'!
testDieRoll
	|die |
	die := DieMorph faces: 6.
	die openInWorld.
	die rollDieTo: 4.

	die rollDieTo: 2	! !

!DieMorphTestCase methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/22/2015 07:29'!
testTwoDiceRoll
	|die1  die2 |
	die1 := DieMorph faces: 6.
	die2 := DieMorph faces: 6.
	
	die1 openInHand .
	die2 openInWorld.

	die1 rollDieTo: 4.
	die2 rollDieTo: 2.	
! !

TestCase subclass: #DieViewTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonView'!

!DieViewTestCase methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/22/2015 07:51'!
testDie
	|myRoll   myDieModel dieView |
	myDieModel := Dice new.
	
	dieView := DieView dieModel: myDieModel .
	
	myRoll := myDieModel  roll.
	
	Transcript show: myRoll .! !

Observer subclass: #DieView
	instanceVariableNames: 'dieMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonView'!

!DieView commentStamp: 'AhmedSoliman 7/22/2015 07:36' prior: 0!
I am responsible for observing the Die Model to represent it visually!

!DieView class methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/22/2015 07:50'!
dieModel: aModel
	^self new dieModel: aModel
	! !

!DieView methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/23/2015 06:10'!
dieModel: aModel
	aModel addObserver: self.	
	! !

!DieView methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/23/2015 09:10'!
dieMorph
	^dieMorph ! !

!DieView methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/22/2015 07:55'!
initialize
	super initialize.
	dieMorph  := DieMorph faces: 6.
	"die2 := DieMorph faces: 6."
	
	dieMorph  openInWorld  .
	"die2 openInWorld."

	
	! !

!DieView methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/25/2015 20:59'!
notify
	
	
	dieMorph  rollDieTo: ( observable  currentRoll ).
	! !

BorderedMorph subclass: #DieMorph
	instanceVariableNames: 'faces dieValue isStopped counter maxRolls valueToSet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonView'!

!DieMorph commentStamp: 'AhmedSoliman 7/20/2015 07:17' prior: 0!
Class to define the face of the dice!

!DieMorph class methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 07:18'!
faces: aNumber
	^self new faces: aNumber! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 08:11'!
dieValue: aNumber
	"method to set the current face value on the dice"
	((aNumber isInteger and: [ aNumber > 0 ]) and: [ aNumber <= faces ])
		ifTrue: [ 
			dieValue := aNumber.
			self changed ]! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 08:41'!
drawDotOn: aCanvas at: aPoint
	aCanvas fillOval: (Rectangle center: self position + (self extent * aPoint) extent: self extent / 6) color: Color red borderWidth: 1 borderColor: Color black! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 08:34'!
drawOn: aCanvas
	| theCanvas |
	theCanvas := aCanvas asAlphaBlendingCanvas: 0.9.
	super drawOn: theCanvas.
	(self perform: ('face' , dieValue asString) asSymbol) do: [ :aPoint | self drawDotOn: theCanvas at: aPoint ]! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 07:22'!
face1
	^{0.5@0.5}
! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 07:23'!
face2
	^{0.25@0.25 . 0.75@0.75}

! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 07:23'!
face3
	^{0.25@0.25 . 0.75@0.75 . 0.5@0.5}

! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 07:24'!
face4
	^{0.25@0.25 . 0.75@0.25 . 0.75@0.75 . 0.25@0.75}

! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 07:24'!
face5
	^{0.25@0.25 . 0.75@0.25 . 0.75@0.75 . 0.25@0.75 . 0.5@0.5}

! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 07:25'!
face6
	^{0.25@0.25 . 0.75@0.25 . 0.75@0.75 . 0.25@0.75 . 0.25@0.5 . 0.75@0.5}

! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 08:21'!
faces: aNumber
	"Set the number of faces"

	((aNumber isInteger and: [ aNumber > 0 ]) and: [ aNumber <= 6 ])
		ifTrue: [ faces := aNumber ]! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/22/2015 07:16'!
handlesMouseDown: anEvent
	"^true"
	^false! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/23/2015 13:31'!
initialize
	super initialize.
	self extent: 50 @ 50.
	self
		useGradientFill;
		borderWidth: 2;
		useRoundedCorners.
	self setBorderStyle: #complexRaised.
	self fillStyle direction: self extent.
	self color: Color white.
	dieValue := 1.
	maxRolls := 5.
	counter := 0.
	valueToSet := 1.
	faces := 6.
	isStopped := false! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 08:14'!
mouseDown: anEvent
	anEvent redButtonPressed
		ifTrue: [ isStopped := isStopped not ]! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/22/2015 07:19'!
rollDieTo: aNumber
	"Rolls the die to a specific number"

	valueToSet := aNumber .
	isStopped := false.
	counter := 0.
	self startStepping .	! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/22/2015 07:25'!
step
	"a step in the animation as long as the dice did not stop rolling"
	counter := counter + 1.
	counter > maxRolls
		ifTrue: [ isStopped := true. self dieValue: valueToSet ].
	isStopped
		ifFalse: [ self dieValue: (1 to: faces) atRandom ]! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 08:30'!
stepTime
	"controls the animation lapse time"
	^ 300! !

Morph subclass: #BackgammonBoard
	instanceVariableNames: 'length surface current points checkers controller'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonView'!

!BackgammonBoard commentStamp: 'DavidOvergaard 7/14/2015 19:08' prior: 0!
This class draws the backgammon board!

!BackgammonBoard class methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 21:30'!
createNewBoard
	^BackgammonBoard new openInWorld.! !

!BackgammonBoard class methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 20:41'!
createNewBoard: aController
	|myBoard|
	
	myBoard := BackgammonBoard new createNewBoard: aController.
	^myBoard openInWorld.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 20:32'!
CreateNewController: aController
	controller := aController.
	^BackgammonBoard openInWorld.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 23:35'!
addCheckerAtPoint: pointNum color: aColor
	| aChecker checkerWidth pointCenter checkerCenter y_offset |	
	checkerWidth := (((surface width)/17) asInteger) * 0.9.
	
	pointCenter := ((points at: pointNum) centerLocation).
	
"	y_offset := (checkerWidth * ((points at: pointNum) numCheckers)).
	pointNum <= 12
	ifTrue: [ 
		y_offset := y_offset * -1.
		 ]."
	y_offset := (points at: pointNum) getYoffset: checkerWidth.

	checkerCenter := (pointCenter x)@((pointCenter y) + y_offset).
	
	aChecker := BChecker diameter: checkerWidth location: checkerCenter color: aColor board: self.
	checkers add: aChecker.
	self addMorph: (aChecker shape).
	(points at: pointNum) addChecker.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/14/2015 19:56'!
backgroundColor
	^(Color r: 0.69 g: 0.45 b: 0.26)! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/30/2015 20:36'!
bearOffSelectedChecker: aColor
	checkers doWithIndex: [ :aChecker  :i|
		((aChecker shape selected) & (aChecker color = aColor))
			ifTrue: [ 
				self removeMorph: (aChecker shape).
				"checkers remove:aChecker."
				controller updatedBearOffCheckerCountByColor: aColor checker:(aChecker observable).
				^ self
			 ].
		 ].
	^ self! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/14/2015 20:00'!
boardRatio
	^0.75.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 20:29'!
checkers
	^checkers.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'xl 7/23/2015 01:02'!
createBar
	| x_loc y_loc |
		
	x_loc := (surface width) /2 - 40.
	y_loc := 0.
	
	self addMorph: (Morph new extent: (30@(surface height)); color: (Color brown); position: x_loc@y_loc)! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 23:30'!
createBottomPointsWidth: pointWidth height: pointHeight
	| x_loc x_offset y_loc pointIndex |
		
	x_loc := (surface width) - (pointWidth / 2).
	x_offset := pointWidth * 2.
	x_loc := x_loc - x_offset.
	y_loc := (surface height).
	
	pointIndex := 1.
	1 to: 3 do: [ :x |
		points add: (BackgammonPoint width: pointWidth height: pointHeight location: x_loc@y_loc pointsUp: 1 color: (self evenPointsColor) index: pointIndex).
		x_loc := x_loc - pointWidth.
		pointIndex := pointIndex + 1.
		
		points add: (BackgammonPoint width: pointWidth height: pointHeight location: x_loc@y_loc pointsUp: 1 color: (self oddPointsColor) index: pointIndex).
		x_loc := x_loc - pointWidth.
		pointIndex := pointIndex + 1.
	].
	
	x_loc := x_loc - x_offset.
	
	1 to: 3 do: [ :x |
		points add: (BackgammonPoint width: pointWidth height: pointHeight location: x_loc@y_loc pointsUp: 1 color: (self evenPointsColor) index: pointIndex).
		x_loc := x_loc - pointWidth.
		
		pointIndex := pointIndex + 1.
		
		points add: (BackgammonPoint width: pointWidth height: pointHeight location: x_loc@y_loc pointsUp: 1 color: (self oddPointsColor) index: pointIndex).
		x_loc := x_loc - pointWidth.
		
		pointIndex := pointIndex + 1.
	].! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 20:39'!
createNewBoard: aController
	controller := aController.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:43'!
createPoints
	| pointWidth pointHeight |
	
	points := OrderedCollection new.
	
	pointWidth := (((surface width)/17) asInteger).
	pointHeight := ((surface height / 2) * (-0.9)).
	
	self createBottomPointsWidth: pointWidth height: pointHeight.
	self createTopPointsWidth: pointWidth height: pointHeight.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 23:39'!
createTopPointsWidth: pointWidth height: pointHeight
	| x_loc x_offset y_loc pointIndex |
	
	x_loc := pointWidth / 2.
	x_offset := (surface width - (16 * pointWidth)).
	x_loc := x_loc + x_offset.
	y_loc := 0.
	
	pointIndex := 13.
	
	1 to: 3 do: [ :x |
		points add: (BackgammonPoint width: pointWidth height: pointHeight location: x_loc@y_loc pointsUp: -1 color: (self evenPointsColor) index: pointIndex).
		x_loc := x_loc + pointWidth.
		
		pointIndex := pointIndex + 1.
		
		points add: (BackgammonPoint width: pointWidth height: pointHeight location: x_loc@y_loc pointsUp: -1 color: (self oddPointsColor) index: pointIndex).
		x_loc := x_loc + pointWidth.
		
		pointIndex := pointIndex + 1.
	].

	x_loc := x_loc + (pointWidth * 2).

	1 to: 3 do: [ :x |
		points add: (BackgammonPoint width: pointWidth height: pointHeight location: x_loc@y_loc pointsUp: -1 color: (self evenPointsColor) index: pointIndex).
		x_loc := x_loc + pointWidth.
		
		pointIndex := pointIndex + 1.
		
		points add: (BackgammonPoint width: pointWidth height: pointHeight location: x_loc@y_loc pointsUp: -1 color: (self oddPointsColor) index: pointIndex).
		x_loc := x_loc + pointWidth.
		
		pointIndex := pointIndex + 1.
	].! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/23/2015 14:27'!
displayNameForPlayer1: player1Name Player2: player2Name

	
	| buttonWidth buttonHeight boardHeight nameLabel |
	buttonWidth := 50.
	buttonHeight := 20.
	boardHeight := length .
	nameLabel := ((LabelMorph newLabel: player1Name) 
					minWidth: buttonWidth; 
					extent: buttonWidth@buttonHeight;
					left: 10;
					top: 10).
		
		nameLabel := ((LabelMorph newLabel: player2Name)
					
					minWidth: buttonWidth; 
					extent: buttonWidth@buttonHeight;
					left: 100;
					top: 10).! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'xl 7/24/2015 01:27'!
drawBearOffChecker1With: aBOChecker 
	| x_loc y_loc |
		
	x_loc := (surface width) - 80.
	y_loc := 30.
	aBOChecker shape moveTo: (x_loc@y_loc) at:self.
	self addMorph: (aBOChecker shape)! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'xl 7/24/2015 01:27'!
drawBearOffChecker2With: aBOChecker
	| x_loc y_loc |
		
	x_loc := (surface width) - 80.
	y_loc := (surface height) - 80.
	aBOChecker shape moveTo: (x_loc@y_loc) at:self.
	self addMorph: (aBOChecker shape)! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 21:38'!
drawOn: aCanvas
	self render.
	
	aCanvas drawImage: surface asForm at: self bounds origin.

"	pointWidth := (((surface width)/17) asInteger).
	temp_loc := (points at: 2) location.
	temp_loc setX: (temp_loc x) - (pointWidth * 0.9 / 2) setY: (temp_loc y) - (pointWidth * 0.9).
	
	checker1 := BChecker diameter: (pointWidth * 0.9) location: temp_loc color: (Color red).
	self addMorph: (checker1 shape)."! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/14/2015 19:57'!
evenPointsColor
	^(Color r: 0.93 g: 0.78 b: 0.62)! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'xl 7/22/2015 00:31'!
extraWidth
	^ extraWidth! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'xl 7/22/2015 00:31'!
extraWidth: aValue
	extraWidth := aValue.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'xl 7/22/2015 00:32'!
getBoardSize
	"Ratio based on maximum Danish Backgammon Federation tournament size: http://www.bkgm.com/rgb/rgb.cgi?view+842"
	^((self length) + (self extraWidth))@((self boardRatio)*(self length)).! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'xl 7/18/2015 02:00'!
handlesMouseDown: evt
    ^ true! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'xl 7/29/2015 23:45'!
indexAt: aPosition
	| tmp homeWidth |
	tmp := 1.
	points do: [ :aPoint |
		(aPoint shapeIncludesPosition: aPosition)
		ifTrue: [ 
			Transcript show: ('at point:').
			Transcript show: tmp.
			^tmp.
			 ].
		tmp := tmp + 1.
		 ].
	
	"homeWidth := (((self getBoardSize) x) / 17) * 2."
	homeWidth := ((self getBoardSize) x) - 120.
	(aPosition x) >= homeWidth
	ifTrue: [ 
		(aPosition y) <= ((self getBoardSize y) / 2)
		ifTrue: [ 
			tmp := 25.
			 ]
		ifFalse: [ 
			tmp := 26.
			 ].
		
		^tmp
		].
	
	^(-1).! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'xl 7/24/2015 01:19'!
initialize
	super initialize.
	self length: 1000.
	self extraWidth: 120. 
	self extent: (self getBoardSize).
	self color: (self backgroundColor).
	surface := AthensCairoSurface extent: (self extent).
	checkers := OrderedCollection new.

	self createPoints.
	self createBar.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 20:30'!
lastAddedChecker
	^(checkers at: (checkers size)).! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/14/2015 20:01'!
length
	^length.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/14/2015 19:34'!
length: aValue
	length := aValue.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'xl 7/30/2015 02:00'!
mouseUp: t1
	| locIndex  |
	
	checkers doWithIndex: [ :aChecker  :i|
		(aChecker shape selected)
			ifTrue: [ 
"				self moveCheckerNum: i toPoint: 5."
				aChecker shape toggleSelected.
				locIndex := (self indexAt: (t1 position)).				
				
				(locIndex >= 1) & (locIndex <= 24)
				ifTrue: [ 
					controller updatedChecker: aChecker toPointNum: locIndex.
					]
				ifFalse: [
					(locIndex >= 25) & (locIndex <= 26)
					ifTrue: [ 
						controller updatedChecker: aChecker toHome: locIndex.
						 ]
					ifFalse:[
						controller model bar moveChecker: ((controller model player2Checkers ) at:1 ) .
						].
					].
			 ].
		 ].
	^ self! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 21:48'!
moveCheckerNum: checkerIdx toPoint: pointNum	
	| aChecker pointWidth temp_loc |	
	pointWidth := (((surface width)/17) asInteger).
	temp_loc := ((points at: pointNum) centerLocation) copy.
	temp_loc setX: (temp_loc x) - (pointWidth * 0.9 / 2) setY: (temp_loc y) - (pointWidth * 0.9).
	
	aChecker := checkers at: checkerIdx.
	(aChecker shape) position: temp_loc.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/14/2015 19:57'!
oddPointsColor
	^(Color r: 0.43 g: 0.31 b: 0.2)! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/24/2015 19:57'!
pointAt: aPosition
	| tmp |
	tmp := 1.
"	Halt now."
	points do: [ :aPoint |
		(aPoint shapeIncludesPosition: aPosition)
		ifTrue: [ 
"			Transcript show: ('at point:').
			Transcript show: tmp."
			^tmp.
			 ].
		tmp := tmp + 1.
		 ].
	
	^(-1).! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:43'!
points
	^points.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:43'!
render
	surface drawDuring: [:canvas|
		surface clear: (self backgroundColor).
		
		points do: [ :aPoint |
			canvas setShape: (aPoint shape).
			canvas setPaint: (aPoint color).
			canvas draw.
		 ].
	].! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/14/2015 20:00'!
width
	^(length * (self boardRatio)).! !

Morph subclass: #NumberCheckMorph
	instanceVariableNames: 'surface textMorph circleMorph board playerColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonView'!

!NumberCheckMorph commentStamp: '<historical>' prior: 0!
NumberCheckMorph!

!NumberCheckMorph class methodsFor: 'as yet unclassified' stamp: 'xl 7/22/2015 01:00'!
createNumberCheckMorph
	^NumberCheckMorph new openInWorld.! !

!NumberCheckMorph class methodsFor: 'as yet unclassified' stamp: 'xl 7/23/2015 23:53'!
diameter: diameter color: aColor
	^ self new diameter: diameter location: (0@0) color: aColor! !

!NumberCheckMorph class methodsFor: 'as yet unclassified' stamp: 'xl 7/23/2015 22:13'!
diameter: diameter location: location color: aColor
	^ self new diameter: diameter location: location color: aColor! !

!NumberCheckMorph methodsFor: 'as yet unclassified' stamp: 'xl 7/24/2015 01:26'!
board
	^board! !

!NumberCheckMorph methodsFor: 'as yet unclassified' stamp: 'xl 7/24/2015 01:26'!
board: aBoard
	board := aBoard! !

!NumberCheckMorph methodsFor: 'as yet unclassified' stamp: 'xl 7/24/2015 01:33'!
diameter: diameter location: location color: aColor
   self extent: (diameter@diameter).
	self left: ((location) x).
	self top: ((location) y).
	self color: (Color transparent).
	circleMorph := (CircleMorph new) extent: (diameter@diameter); color: aColor; borderWidth: 0; left: ((location) x); top: ((location) y).
	self addMorph: circleMorph.
	textMorph := ((TextMorph new) beAllFont: ((TextStyle default fontOfSize: 36) emphasized: 1); 	
			contents: '0';color: Color white; 
			center: self center; extent: (diameter@diameter)).
	self addMorph: textMorph.
	self playerColor: aColor.
   ^self.! !

!NumberCheckMorph methodsFor: 'as yet unclassified' stamp: 'xl 7/24/2015 01:16'!
handlesMouseDown: anEvent
	^true! !

!NumberCheckMorph methodsFor: 'as yet unclassified' stamp: 'xl 7/23/2015 22:33'!
initialize
	super initialize.
"	self extent: (100@100).
	self color: (Color yellow).
	
	
	self addMorph: ((CircleMorph new) extent: (100@100); color: (Color red); borderWidth: 0).
	self addMorph: ((TextMorph new) beAllFont: ((TextStyle default fontOfSize: 36) emphasized: 1); 	
			contents: '1';color: Color white; 
			center: self center; extent: (100@100))."
			
"	self addMorph: ((TextMorph new 
   beAllFont: ((TextStyle default fontOfSize: 36) emphasized: 1);
   color: Color white; 
	center: self center; extent: (100@100);
   contents: '1'))"! !

!NumberCheckMorph methodsFor: 'as yet unclassified' stamp: 'xl 7/24/2015 00:42'!
label: aNumber
	textMorph contents: (aNumber asString). ! !

!NumberCheckMorph methodsFor: 'as yet unclassified' stamp: 'xl 7/24/2015 01:34'!
mouseUp: t1
	self board bearOffSelectedChecker: (self playerColor).
	^ self! !

!NumberCheckMorph methodsFor: 'as yet unclassified' stamp: 'xl 7/24/2015 01:27'!
moveTo: aLocation at:aBoard
	self left: ((aLocation) x).
	self top: ((aLocation) y).
	circleMorph left: ((aLocation) x).
	circleMorph top: ((aLocation) y).
	self board: aBoard.! !

!NumberCheckMorph methodsFor: 'as yet unclassified' stamp: 'xl 7/24/2015 01:33'!
playerColor
	^playerColor! !

!NumberCheckMorph methodsFor: 'as yet unclassified' stamp: 'xl 7/24/2015 01:33'!
playerColor: aColor
	playerColor := aColor! !

Object subclass: #BackgammonLocation
	instanceVariableNames: 'locations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonView'!

!BackgammonLocation commentStamp: 'DavidOvergaard 7/21/2015 21:30' prior: 0!
Keep track of all possible locations x, y positions!

BackgammonLocation subclass: #BackgammonPoint
	instanceVariableNames: 'shape color centerLocation numCheckers shapeRightCorner shapeLeftCorner shapeTop width pointIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonView'!

!BackgammonPoint commentStamp: 'DavidOvergaard 7/14/2015 20:02' prior: 0!
A backgammon point!

!BackgammonPoint class methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:22'!
width: pointWidth height: pointHeight location: centerLocation pointsUp: pointsUp color: aColor
	^BackgammonPoint new width: pointWidth height: pointHeight location: centerLocation pointsUp: pointsUp color: aColor.! !

!BackgammonPoint class methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 23:28'!
width: pointWidth height: pointHeight location: centerLocation pointsUp: pointsUp color: aColor index: anIndex
	^BackgammonPoint new width: pointWidth height: pointHeight location: centerLocation pointsUp: pointsUp color: aColor index: anIndex.! !

!BackgammonPoint methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 22:07'!
addChecker
	numCheckers := numCheckers + 1.! !

!BackgammonPoint methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 21:47'!
centerLocation
	^centerLocation! !

!BackgammonPoint methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:23'!
color
	^color! !

!BackgammonPoint methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 23:20'!
decrementChecker
	numCheckers := numCheckers - 1.! !

!BackgammonPoint methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 23:39'!
getYoffset: checkerWidth
	| y_offset |	

	y_offset := (checkerWidth * (self numCheckers)).
	pointIndex <= 12
	ifTrue: [ 
		y_offset := y_offset * -1.
	].

	^y_offset.! !

!BackgammonPoint methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 22:06'!
initialize
	super initialize.
	numCheckers := 0.! !

!BackgammonPoint methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 22:07'!
numCheckers
	^numCheckers.! !

!BackgammonPoint methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:02'!
shape
	^shape! !

!BackgammonPoint methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 23:05'!
shapeIncludesPosition: aPosition
	| included |
	
	included := false.
	
	((aPosition x) >= (shapeLeftCorner x)) & ((aPosition x <= (shapeRightCorner x)))
	ifTrue: [
		(shapeRightCorner y) > (shapeTop y)
		ifTrue: [ 
			((aPosition y) >= (shapeTop y))
			ifTrue: [ 
				included := true.
				 ].
			]
		ifFalse: [
			((aPosition y) <= (shapeTop y))
			ifTrue: [ 
				included := true.
				 ].
			 ]
		 ].
	
	^included.! !

!BackgammonPoint methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 23:03'!
width: pointWidth height: pointHeight location: startLocation pointsUp: pointsUp color: aColor
	| surface y_offset |

	pointsUp = 1
	ifTrue: [ 
		y_offset := pointWidth * 0.9.
		 ]
	ifFalse: [ 
		y_offset := 0.
		 ].
	centerLocation := ((startLocation x) - (pointWidth * 0.9 / 2))@((startLocation y) - y_offset).

	color := aColor.
	
	"Need a surface to use shape creation"
	surface := AthensCairoSurface extent: 0@0.
	
	shapeRightCorner := ((startLocation x) + (pointWidth / 2))@(startLocation y).
	shapeTop := (startLocation x)@(startLocation y) + (pointHeight * pointsUp).
	shapeLeftCorner := ((startLocation x) - (pointWidth / 2))@(startLocation y).

	shape := surface createPath: [:builder |
		builder 
			moveTo: startLocation;
			lineTo: (pointWidth/2)@0;
			lineTo: (-1*(pointWidth/2))@(pointHeight * pointsUp);
			lineTo: (-1*pointWidth/2)@(-1 * (pointHeight * pointsUp));
			close
		].! !

!BackgammonPoint methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 23:33'!
width: pointWidth height: pointHeight location: startLocation pointsUp: pointsUp color: aColor index: anIndex
	| surface y_offset |

	pointIndex := anIndex.

	pointsUp = 1
	ifTrue: [ 
		y_offset := pointWidth * 0.9.
		 ]
	ifFalse: [ 
		y_offset := 0.
		 ].
	centerLocation := ((startLocation x) - (pointWidth * 0.9 / 2))@((startLocation y) - y_offset).

	color := aColor.
	
	"Need a surface to use shape creation"
	surface := AthensCairoSurface extent: 0@0.
	
	shapeRightCorner := ((startLocation x) + (pointWidth / 2))@(startLocation y).
	shapeTop := (startLocation x)@(startLocation y) + (pointHeight * pointsUp).
	shapeLeftCorner := ((startLocation x) - (pointWidth / 2))@(startLocation y).

	shape := surface createPath: [:builder |
		builder 
			moveTo: startLocation;
			lineTo: (pointWidth/2)@0;
			lineTo: (-1*(pointWidth/2))@(pointHeight * pointsUp);
			lineTo: (-1*pointWidth/2)@(-1 * (pointHeight * pointsUp));
			close
		].! !

Object subclass: #ViewObserver
	instanceVariableNames: 'observable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonView'!

!ViewObserver commentStamp: 'DavidOvergaard 7/21/2015 20:29' prior: 0!
An Observer for changes in the observable class!

ViewObserver subclass: #BChecker
	instanceVariableNames: 'mouseAction diameter location shape color board'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonView'!

!BChecker commentStamp: '<historical>' prior: 0!
checker!

!BChecker class methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/22/2015 20:24'!
diameter: checkerDiameter location: centerLocation color: aColor
	^BChecker new diameter: checkerDiameter location: centerLocation color: aColor.! !

!BChecker class methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 23:13'!
diameter: checkerDiameter location: centerLocation color: aColor board: aBoard
	^BChecker new diameter: checkerDiameter location: centerLocation color: aColor board: aBoard.! !

!BChecker class methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/22/2015 20:24'!
inPoint: point
	super initialize. 
	^ ((self new) 	color: Color red; 
					borderWidth: 0; 
					left:20;
					top: 20;
					extent:100 @ 100 ).! !

!BChecker class methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/22/2015 20:24'!
initialize
	super initialize. 
	^ ((self new) 	color: Color red; 
					borderWidth: 0; 
					left:20;
					top: 20;
					extent:100 @ 100 ).! !

!BChecker methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/22/2015 20:23'!
color
	^color! !

!BChecker methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 21:23'!
diameter: checkerDiameter location: centerLocation color: aColor
	diameter := checkerDiameter.
	location := centerLocation.
	color := aColor.
					
	shape := CheckerMorph diameter: checkerDiameter location: centerLocation color: aColor! !

!BChecker methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 23:13'!
diameter: checkerDiameter location: centerLocation color: aColor board: aBoard
	diameter := checkerDiameter.
	location := centerLocation.
	color := aColor.
	board := aBoard.
					
	shape := CheckerMorph diameter: checkerDiameter location: centerLocation color: aColor! !

!BChecker methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/22/2015 20:23'!
initialize
	super initialize.! !

!BChecker methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/22/2015 20:23'!
location
	^location! !

!BChecker methodsFor: 'as yet unclassified' stamp: 'xl 7/29/2015 23:15'!
moveToBar
	(board points at: (board pointAt: ((self shape) topLeftCorner))) decrementChecker.
	(self color = (Color red) )
		ifTrue: [ (self shape) position: ((board width) /2 + 130)@((board height ) /3). ]
		ifFalse: [ (self shape) position: ((board width) /2 + 130)@(2*(board height ) /3). ].! !

!BChecker methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/30/2015 21:25'!
moveToPoint: pointNum
	| centerLocation y_offset pointAt|
	pointAt :=board pointAt: ((self shape)topLeftCorner).
	(pointAt = -1)
	ifFalse:[
		(board points at: pointAt ) decrementChecker.
	].

	centerLocation := ((board points at: pointNum) centerLocation).
	y_offset := (board points at: pointNum) getYoffset: diameter.
	
	(self shape) position: (centerLocation x)@((centerLocation y) + y_offset).
	(board points at: pointNum) addChecker.! !

!BChecker methodsFor: 'as yet unclassified' stamp: 'jChizmar 7/30/2015 19:36'!
notify
| pointNum |
(observable checkerLocation isAPoint)
ifTrue:[
pointNum := (observable checkerLocation) pointNumber.
]
ifFalse:[
	pointNum :=0.
	].
(pointNum = 0)
	ifTrue:[self moveToBar.]
	ifFalse:[self moveToPoint: pointNum.].! !

!BChecker methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/22/2015 20:24'!
shape
	^shape! !

ViewObserver subclass: #NumberCheckerView
	instanceVariableNames: 'shape location diameter color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonView'!

!NumberCheckerView commentStamp: '<historical>' prior: 0!
NumberCheckerView!

!NumberCheckerView class methodsFor: 'as yet unclassified' stamp: 'xl 7/24/2015 00:09'!
diameter: checkerDiameter color: aColor
	^NumberCheckerView new diameter: checkerDiameter color: aColor! !

!NumberCheckerView class methodsFor: 'as yet unclassified' stamp: 'xl 7/24/2015 00:09'!
diameter: checkerDiameter location: centerLocation color: aColor
	^NumberCheckerView new diameter: checkerDiameter location: centerLocation color: aColor! !

!NumberCheckerView methodsFor: 'as yet unclassified' stamp: 'xl 7/23/2015 23:55'!
diameter: checkerDiameter color: aColor
	shape := NumberCheckMorph diameter: checkerDiameter color: aColor! !

!NumberCheckerView methodsFor: 'as yet unclassified' stamp: 'xl 7/23/2015 23:46'!
diameter: checkerDiameter location: centerLocation color: aColor
	location := centerLocation.
	shape := NumberCheckMorph diameter: checkerDiameter location: centerLocation color: aColor! !

!NumberCheckerView methodsFor: 'as yet unclassified' stamp: 'xl 7/23/2015 22:58'!
initialize
	super initialize.! !

!NumberCheckerView methodsFor: 'as yet unclassified' stamp: 'xl 7/30/2015 23:37'!
notify
	shape label: (observable numCheckersOnHome).
	((observable numCheckersOnHome) = 15)
		ifTrue: [ 
			MorphicUIManager default alert: 'You Win!!' title: 'Game Over'
		].! !

!NumberCheckerView methodsFor: 'as yet unclassified' stamp: 'xl 7/24/2015 00:08'!
shape
	^shape! !

!ViewObserver methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 20:29'!
notify
    "Action to notify on e.g.: Change in the checker location"
    Transcript show: 'Some things changed in ', observable asString.! !

!ViewObserver methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 20:29'!
observable
    ^ observable.! !

!ViewObserver methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 20:29'!
observable: anObject
    observable := anObject.! !

CircleMorph subclass: #CheckerMorph
	instanceVariableNames: 'selected offsetColor originalColor selectedColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonView'!

!CheckerMorph commentStamp: '<historical>' prior: 0!
CheckerMorph!

!CheckerMorph class methodsFor: 'as yet unclassified' stamp: 'xl 7/17/2015 23:09'!
createCheckerMorph
	CheckerMorph new openInWorld! !

!CheckerMorph class methodsFor: 'as yet unclassified' stamp: 'xl 7/18/2015 00:28'!
diameter: diameter location: location color: aColor
	^ self new diameter: diameter location: location color: aColor! !

!CheckerMorph methodsFor: 'as yet unclassified' stamp: 'xl 7/17/2015 22:34'!
click: t1
	Transcript open.
	^ self! !

!CheckerMorph methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/18/2015 12:09'!
diameter: diameter location: location color: aColor
   super initialize.
   super color: aColor.
	originalColor := aColor.
	super borderWidth: 0.
	super extent:diameter@diameter.
	super left: ((location) x).
	super top: ((location) y).
   ^self.! !

!CheckerMorph methodsFor: 'as yet unclassified' stamp: 'xl 7/17/2015 23:03'!
drawOn: aCanvas
    aCanvas fillOval: self bounds color: (self color).! !

!CheckerMorph methodsFor: 'as yet unclassified' stamp: 'xl 7/17/2015 23:17'!
handlesMouseDown: evt
    ^ true! !

!CheckerMorph methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/18/2015 12:11'!
initialize
   super initialize.
	super borderWidth: 0.
	super extent:10 @ 10.
   selected := false.
	selectedColor := Color blue.
   ^self.! !

!CheckerMorph methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/18/2015 12:10'!
mouseDown: t1
	self color: selectedColor.
	^ self! !

!CheckerMorph methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/18/2015 12:12'!
mouseUp: t1
	self toggleSelected.
	^ self! !

!CheckerMorph methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/18/2015 12:12'!
onClickExecutionBlock
	self color: offsetColor.! !

!CheckerMorph methodsFor: 'as yet unclassified' stamp: 'xl 7/18/2015 01:59'!
selected
	^selected! !

!CheckerMorph methodsFor: 'as yet unclassified' stamp: 'xl 7/18/2015 02:29'!
selected: aBool
	selected:=aBool! !

!CheckerMorph methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/18/2015 12:10'!
toggleSelected
	"self position: self position + (50 @ 0)."
	(selected)
		ifTrue: [
			self color: originalColor.
			self selected:false.
		]
		ifFalse: [
			self color: selectedColor.
			self selected:true.
		].! !

SimpleSwitchMorph subclass: #EndTurnButton
	instanceVariableNames: 'mouseAction playerTurn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonView'!

!EndTurnButton commentStamp: 'DavidOvergaard 7/28/2015 21:13' prior: 0!
End turn button!

!EndTurnButton class methodsFor: 'initialize' stamp: 'DavidOvergaard 7/28/2015 21:25'!
text: labelText boardHeight: boardHeight

	| buttonWidth buttonHeight |
	buttonWidth := 70.
	buttonHeight := 20.
	
	
	super initialize.
^ ((self new) 	labelString: labelText; 
					minWidth: buttonWidth; 
					extent: buttonWidth@buttonHeight;
					left: 10;
					top: (boardHeight / 2) - (buttonHeight / 2) + 20
				
	).! !

!EndTurnButton methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/28/2015 21:13'!
initialize
	super initialize.
! !

!EndTurnButton methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/28/2015 21:25'!
mouseDown: anEvent
	| model |
	anEvent redButtonPressed
	ifTrue: [ 
		model := MainBoard instance.
	
		(model itsMyTurn = model player1)
			ifTrue:[model itsMyTurn: model player2. model status: 2]
			ifFalse:[model itsMyTurn: model player1. model status: 1].
	].! !

SimpleSwitchMorph subclass: #InputButton
	instanceVariableNames: 'mouseAction playerTurn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonView'!

!InputButton commentStamp: 'jChizmar 7/9/2015 07:56' prior: 0!
A button that responds to input!

!InputButton class methodsFor: 'initialize' stamp: 'AhmedSoliman 7/25/2015 20:16'!
text: labelText boardHeight: boardHeight

	| buttonWidth buttonHeight |
	buttonWidth := 70.
	buttonHeight := 50.
	
	
	super initialize.
^ ((self new) 	labelString: labelText; 
					minWidth: buttonWidth; 
					extent: buttonWidth@buttonHeight;
					left: 10;
					top: (boardHeight / 2) - (buttonHeight / 2)
				
	).! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/25/2015 20:17'!
initialize
	super initialize.
! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/28/2015 21:07'!
mouseDown: anEvent
	| model |
	anEvent redButtonPressed
		ifTrue: [ 
	model := MainBoard instance .
	
	model status = 0
		ifTrue: [ self promptForPlayersNames. model status: 1  ].
	
	(model status =1 or: model status = 2)
		ifTrue: [ self rollDie ] 
		]
	! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/30/2015 19:44'!
promptForPlayersNames
	"Ask each player in turn about their name and update the model"
	"Prompt for player 1"
	| myBoardModel player1Name player2Name controller |
	
	myBoardModel := MainBoard instance.
	
	controller := BackgammonStart getInstance.
	
	(controller isSeverGame = 1)
	ifTrue: [ 
		(controller playerNum = 1)
		ifTrue: [ 
			player1Name := UIManager default request: 'Player 1 name:' initialAnswer: 'Ahmed'.
			myBoardModel player1 nameOfPlayer: player1Name.
		
			player2Name := controller player1ExchangeStringBlocking: player1Name.
			myBoardModel player2 nameOfPlayer: player2Name.
			 ]
		ifFalse: [ 
			player2Name := UIManager default request: 'Player 2 name:' initialAnswer: 'Bob'.
			myBoardModel player2 nameOfPlayer: player2Name.
				
			player1Name := controller player2ExchangeStringBlocking: player2Name.
			myBoardModel player1 nameOfPlayer: player1Name.
			 ]
		 ]
	ifFalse: [
		player1Name := UIManager default request: 'Player 1 name:' initialAnswer: 'Ahmed'.
		myBoardModel player1 nameOfPlayer: player1Name.
	
		"Prompt for player 2"
		player2Name := UIManager default request: 'Player 2 name:' initialAnswer: 'Bob'.
		myBoardModel player2 nameOfPlayer: player2Name.
	].
	
	"myBoardView displayNameForPlayer1: player1Name  Player2: player2Name"! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/27/2015 08:45'!
rollDie
	| rollCommand model|
	model := MainBoard instance  .
	
	rollCommand := (RollCommand new) dice1: (model dice1) dice2: (model dice2).
	rollCommand execute.
	
	Transcript show: (rollCommand dice1 currentRoll).
	Transcript show: (rollCommand dice2 currentRoll);cr.! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/27/2015 08:45'!
step
	
	|  temp model |
	super step.
	

	model:= MainBoard instance .
	
	model isNil 
		ifTrue: [ ^self label: 'New Game'].
	
	( model status = 0 )
		ifTrue: [ temp := 'New Game' ].
		
	 ((model status = 1) or: (model status = 2))
		ifTrue: [ temp:= model itsMyTurn nameOfPlayer, '''s Turn' ].
		
	model status = 3
		ifTrue: [ temp:= 'Game Over' ].
		
	self label: temp.! !
BChecker initialize!
